<?php
/**
 * Optical Store functions and definitions
 *
 * @link https://developer.wordpress.org/themes/basics/theme-functions/
 *
 * @package Optical Store
 */

/* Enqueue script and styles */

function optical_store_enqueue_google_fonts() {

	require_once get_theme_file_path( 'includes/wptt-webfont-loader.php' );

	wp_enqueue_style(
		'Sora',
		optical_store_wptt_get_webfont_url( 'https://fonts.googleapis.com/css2?family=Sora:wght@100..800&display=swap' ),
		array(),
		'1.2.3'
	);

	wp_enqueue_style(
		'Inter',
		optical_store_wptt_get_webfont_url( 'https://fonts.googleapis.com/css2?family=Inter:ital,opsz,wght@0,14..32,100..900;1,14..32,100..900&display=swap' ),
		array(),
		'1.2.3'
	);
}
add_action( 'wp_enqueue_scripts', 'optical_store_enqueue_google_fonts' );

if (!function_exists('optical_store_enqueue_scripts')) {

	function optical_store_enqueue_scripts() {

		wp_enqueue_style(
			'bootstrap-css',
			get_template_directory_uri() . '/assets/css/bootstrap.css',
			array(),'4.5.0'
		);

		wp_enqueue_style(
			'fontawesome-css',
			get_template_directory_uri() . '/assets/css/fontawesome-all.css',
			array(),'4.5.0'
		);

		wp_enqueue_style('optical-store-style', get_stylesheet_uri(), array() );

		wp_enqueue_style(
			'optical-store-responsive-css',
			get_template_directory_uri() . '/assets/css/responsive.css',
			array(),'2.3.4'
		);

		wp_enqueue_script(
			'navigation',
			get_template_directory_uri() . '/assets/js/navigation.js',
			FALSE,
			'1.0',
			TRUE
		);

		wp_enqueue_script(
			'optical-store-script',
			get_template_directory_uri() . '/assets/js/script.js',
			array('jquery'),
			'1.0',
			TRUE
		);

		wp_enqueue_style( 'animate-css', esc_url(get_template_directory_uri()).'/assets/css/animate.css' );

		wp_enqueue_script( 'wow-js', esc_url(get_template_directory_uri()) . '/assets/js/wow.js', array('jquery') );

		require get_parent_theme_file_path( '/includes/color-setting/custom-color-control.php' );
		wp_add_inline_style( 'optical-store-style',$optical_store_theme_custom_setting_css );

		if ( is_singular() ) wp_enqueue_script( 'comment-reply' );

		$css = '';

		if ( get_header_image() ) :

			$css .=  '
				.header-image-box{
					background-image: url('.esc_url(get_header_image()).') !important;
					-webkit-background-size: cover !important;
					-moz-background-size: cover !important;
					-o-background-size: cover !important;
					background-size: cover !important;
					height: 450px;
				    display: flex;
				    align-items: center;
				}';

		endif;

		wp_add_inline_style( 'optical-store-style', $css );

	}

	add_action( 'wp_enqueue_scripts', 'optical_store_enqueue_scripts' );

}

/* Setup theme */

if (!function_exists('optical_store_after_setup_theme')) {

	function optical_store_after_setup_theme() {

		load_theme_textdomain( 'optical-store', get_template_directory() . '/languages' );

		if ( ! isset( $content_width ) ) $content_width = 900;

		register_nav_menus( array(
			'main-menu' => esc_html__( 'Main menu', 'optical-store' ),
		));

		add_theme_support( 'responsive-embeds' );
		add_theme_support( 'woocommerce' );
		add_theme_support( 'align-wide' );
		add_theme_support('title-tag');
		add_theme_support('automatic-feed-links');
		add_theme_support( 'wp-block-styles' );
		add_theme_support('post-thumbnails');
		add_theme_support( 'custom-background', array(
		  'default-color' => 'f3f3f3'
		));

		add_theme_support( 'custom-logo', array(
			'height'      => 150,
			'width'       => 400,
		) );
	
		add_theme_support( 'custom-header', array(
			'default-image' => get_parent_theme_file_uri( '/assets/images/default-header-image.png' ),
			'width' => 1920,
			'flex-width' => true,
			'height' => 400,
			'flex-height' => true,
			'header-text' => false,
		)); 

		register_default_headers( array(
			'default-image' => array(
				'url'           => '%s/assets/images/default-header-image.png',
				'thumbnail_url' => '%s/assets/images/default-header-image.png',
				'description'   => __( 'Default Header Image', 'optical-store' ),
			),
		) );

		add_theme_support( 'html5', array(
			'search-form',
			'comment-form',
			'comment-list',
			'gallery',
			'caption',
		) );

		add_editor_style( array( '/assets/css/editor-style.css' ) );
	
		if ( is_admin() && (!isset($_GET['page']) || $_GET['page'] !== 'optical_store_about')) {
            add_action('admin_notices', 'optical_store_activation_notice');
        }

	}

	add_action( 'after_setup_theme', 'optical_store_after_setup_theme', 999 );

}

function optical_store_activation_notice() {
	$optical_store_meta = get_option( 'optical_store_admin_notice' );
	if (!$optical_store_meta) {
			echo '<div id="optical-store-welcome-notice" class="notice notice-info wpele-activation-notice is-dismissible">';
			echo '<div class="notice-body">';
				echo '<div class="notice-content">';
					echo '<h2>'. esc_html__( 'Welcome to WPElemento', 'optical-store' ) .'</h2>';
					echo '<p>'. esc_html__( 'Thank you for choosing Optical Store theme .To setup the theme, please visit the get started page.', 'optical-store' ) .'</p>';
					echo '<span><a href="'. esc_url( admin_url( 'themes.php?page=optical_store_about' ) ) .'" class="button button-notice">'. esc_html__( 'GET STARTED', 'optical-store' ) .'</a></span>';
					echo '<span><a href="'. esc_url( OPTICAL_STORE_BUY_NOW ) .'" class="button button-notice" target="_blank" >'. esc_html__( 'BUY NOW', 'optical-store' ) .'</a></span>';
					echo '<span><a href="'. esc_url( OPTICAL_STORE_LIVE_DEMO ) .'" class="button button-notice" target="_blank" >'. esc_html__( 'DEMO', 'optical-store' ) .'</a></span>';
				echo '</div>';
				echo '<div class="notice-icon">';
					echo '<img src="'.esc_url(get_template_directory_uri()).'/includes/getstart/images/get-logo.png ">';
				echo '</div>';
			echo '</div>';
		echo '</div>';
	}
}

/* Get post comments */

if (!function_exists('optical_store_comment')) :
    /**
     * Template for comments and pingbacks.
     *
     * Used as a callback by wp_list_comments() for displaying the comments.
     */
    function optical_store_comment($comment, $args, $depth){

        if ('pingback' == $comment->comment_type || 'trackback' == $comment->comment_type) : ?>

            <li id="comment-<?php comment_ID(); ?>" <?php comment_class('media'); ?>>
            <div class="comment-body">
                <?php esc_html_e('Pingback:', 'optical-store');
                comment_author_link(); ?><?php edit_comment_link(__('Edit', 'optical-store'), '<span class="edit-link">', '</span>'); ?>
            </div>

        <?php else : ?>

        <li id="comment-<?php comment_ID(); ?>" <?php comment_class(empty($args['has_children']) ? '' : 'parent'); ?>>
            <article id="div-comment-<?php comment_ID(); ?>" class="comment-body media mb-4">
                <a class="pull-left" href="#">
                    <?php if (0 != $args['avatar_size']) echo get_avatar($comment, $args['avatar_size']); ?>
                </a>
                <div class="media-body">
                    <div class="media-body-wrap card">
                        <div class="card-header">
                            <h5 class="mt-0"><?php /* translators: %s: author */ printf('<cite class="fn">%s</cite>', get_comment_author_link() ); ?></h5>
                            <div class="comment-meta">
                                <a href="<?php echo esc_url(get_comment_link($comment->comment_ID)); ?>">
                                    <time datetime="<?php comment_time('c'); ?>">
                                        <?php /* translators: %s: Date */ printf( esc_html__('%1$s at %2$s','optical-store'), esc_html( get_comment_date() ), esc_html( get_comment_time() ) ); ?>
                                    </time>
                                </a>
                                <?php edit_comment_link( __( 'Edit', 'optical-store' ), '<span class="edit-link">', '</span>' ); ?>
                            </div>
                        </div>

                        <?php if ('0' == $comment->comment_approved) : ?>
                            <p class="comment-awaiting-moderation"><?php esc_html_e('Your comment is awaiting moderation.', 'optical-store'); ?></p>
                        <?php endif; ?>

                        <div class="comment-content card-block">
                            <?php comment_text(); ?>
                        </div>

                        <?php comment_reply_link(
                            array_merge(
                                $args, array(
                                    'add_below' => 'div-comment',
                                    'depth' => $depth,
                                    'max_depth' => $args['max_depth'],
                                    'before' => '<footer class="reply comment-reply card-footer">',
                                    'after' => '</footer><!-- .reply -->'
                                )
                            )
                        ); ?>
                    </div>
                </div>
            </article>

            <?php
        endif;
    }
endif; // ends check for optical_store_comment()

if (!function_exists('optical_store_widgets_init')) {

	function optical_store_widgets_init() {

		register_sidebar(array(

			'name' => esc_html__('Sidebar','optical-store'),
			'id'   => 'optical-store-sidebar',
			'description'   => esc_html__('This sidebar will be shown next to the content.', 'optical-store'),
			'before_widget' => '<div id="%1$s" class="sidebar-widget %2$s">',
			'after_widget'  => '</div>',
			'before_title'  => '<h4 class="title">',
			'after_title'   => '</h4>'

		));

		register_sidebar(array(

			'name' => esc_html__('Page Sidebar','optical-store'),
			'id'   => 'sidebar-2',
			'description'   => esc_html__('This sidebar will be shown next to the content.', 'optical-store'),
			'before_widget' => '<div id="%1$s" class="sidebar-widget %2$s">',
			'after_widget'  => '</div>',
			'before_title'  => '<h4 class="title">',
			'after_title'   => '</h4>'

		));

		register_sidebar(array(

			'name' => esc_html__('Sidebar three','optical-store'),
			'id'   => 'sidebar-3',
			'description'   => esc_html__('This sidebar will be shown on blog pages.', 'optical-store'),
			'before_widget' => '<div id="%1$s" class="sidebar-widget %2$s">',
			'after_widget'  => '</div>',
			'before_title'  => '<h4 class="title">',
			'after_title'   => '</h4>'
		));

		register_sidebar(array(

			'name' => esc_html__('Footer sidebar 1','optical-store'),
			'id'   => 'footer1-sidebar',
			'description'   => esc_html__('It appears in the footer 1.', 'optical-store'),
			'before_widget' => '<aside id="%1$s" class="%2$s">',
			'after_widget'  => '</aside>',
			'before_title'  => '<h4 class="title">',
			'after_title'   => '</h4>'
		));

		register_sidebar(array(

			'name' => esc_html__('Footer sidebar 2','optical-store'),
			'id'   => 'footer2-sidebar',
			'description'   => esc_html__('It appears in the footer 2.', 'optical-store'),
			'before_widget' => '<aside id="%1$s" class="%2$s">',
			'after_widget'  => '</aside>',
			'before_title'  => '<h4 class="title">',
			'after_title'   => '</h4>'
		));

		register_sidebar(array(

			'name' => esc_html__('Footer sidebar 3','optical-store'),
			'id'   => 'footer3-sidebar',
			'description'   => esc_html__('It appears in the footer 3.', 'optical-store'),
			'before_widget' => '<aside id="%1$s" class="%2$s">',
			'after_widget'  => '</aside>',
			'before_title'  => '<h4 class="title">',
			'after_title'   => '</h4>'
		));

		register_sidebar(array(

			'name' => esc_html__('Footer sidebar 4','optical-store'),
			'id'   => 'footer4-sidebar',
			'description'   => esc_html__('It appears in the footer 4.', 'optical-store'),
			'before_widget' => '<aside id="%1$s" class="%2$s">',
			'after_widget'  => '</aside>',
			'before_title'  => '<h4 class="title">',
			'after_title'   => '</h4>'
		));

	}

	add_action( 'widgets_init', 'optical_store_widgets_init' );

}

function optical_store_the_breadcrumb() {
	if (!is_home()) {
		echo '<a href="';
		echo esc_url( home_url() );
		echo '">';
		bloginfo('name');
		echo "</a> >> ";
		if (is_category() || is_single()) {
			the_category(' , ');
			if (is_single()) {
				echo " >> ";
				the_title();
			}
		} elseif (is_page()) {
			the_title();
		}
	}
}

/**
 * Change number or products per row to 4
 */
add_filter('loop_shop_columns', 'optical_store_loop_columns', 999);
if (!function_exists('optical_store_loop_columns')) {
	function optical_store_loop_columns() {
		return get_theme_mod( 'optical_store_products_per_row', '4' ); 
	}
}

//Change number of products that are displayed per page (shop page)
add_filter( 'loop_shop_per_page', 'optical_store_products_per_page' );
function optical_store_products_per_page( $cols ) {
  	return  get_theme_mod( 'optical_store_products_per_page',8);
}

function optical_store_enqueue_setting() {

define('OPTICAL_STORE_FREE_THEME_DOC', 'https://preview.wpelemento.com/theme-documentation/optical-store/');
define('OPTICAL_STORE_SUPPORT', 'https://wordpress.org/support/theme/optical-store/');
define('OPTICAL_STORE_REVIEW', 'https://wordpress.org/support/theme/optical-store/reviews/');
define('OPTICAL_STORE_BUY_NOW', 'https://www.wpelemento.com/products/optician-wordpress-theme ');
define('OPTICAL_STORE_LIVE_DEMO', 'https://preview.wpelemento.com/optical-store/');
define('OPTICAL_STORE_THEME_BUNDLE', 'https://www.wpelemento.com/products/wordpress-theme-bundle');

require get_template_directory() .'/includes/tgm/tgm.php';
require get_template_directory() . '/includes/customizer.php';
load_template( trailingslashit( get_template_directory() ) . '/includes/go-pro/class-upgrade-pro.php' );

/* Plugin Activation */
require get_template_directory() . '/includes/getstart/plugin-activation.php';

/* Implement the About theme page */
require get_template_directory() . '/includes/getstart/getstart.php';
require get_template_directory() . '/includes/product-create.php';

if( class_exists( 'Whizzie' ) ) {
	$Whizzie = new Whizzie();
}

}
add_action('after_setup_theme', 'optical_store_enqueue_setting');

add_filter('wpelemento_importer_plugins_list', function ($optical_store_plugins) {
    $optical_store_desired_order = ['woocommerce', 'yith-woocommerce-wishlist' , 'woolentor-addons'];
    foreach (['all', 'install', 'update', 'activate'] as $optical_store_section) {
        if (!isset($optical_store_plugins[$optical_store_section])) continue;

        $optical_store_reordered = [];

        foreach ($optical_store_desired_order as $optical_store_slug) {
            if (isset($optical_store_plugins[$optical_store_section][$optical_store_slug])) {
                $optical_store_reordered[$optical_store_slug] = $optical_store_plugins[$optical_store_section][$optical_store_slug];
                unset($optical_store_plugins[$optical_store_section][$optical_store_slug]);
            }
        }
        $optical_store_plugins[$optical_store_section] = $optical_store_reordered + $optical_store_plugins[$optical_store_section];
    }

    return $optical_store_plugins;
});

function optical_store_dismissed_notice() {
	check_ajax_referer( 'optical_store_dismissed_notice_nonce', 'nonce' );
	if ( ! current_user_can( 'manage_options' ) ) {
		wp_die( esc_html__( 'You do not have permission to perform this action.', 'optical-store' ) );
	}
	update_option( 'optical_store_admin_notice', true );
	wp_die();
}
add_action( 'wp_ajax_optical_store_dismissed_notice', 'optical_store_dismissed_notice' );

add_action('after_switch_theme', 'optical_store_getstart_setup_options');
function optical_store_getstart_setup_options () {
    update_option('optical_store_admin_notice', false );
}

?>